"use strict";

{
	const C3 = self.C3;
	C3.Behaviors.Rex_Turntable.Instance = class Rex_TurntableInstance extends C3.SDKBehaviorInstanceBase
	{
		constructor(behInst, properties)
		{
			super(behInst);
			this.inst = this._inst.GetWorldInfo();
			this.target = {"a":0, "cw":true};
			this.dec = 0;
			this.is_rotating = false;
			this.current_speed = 0;
			this.next_speed = 0;
			this.remain_distance = 0;
			this.is_my_call = false;
			if (properties)
			{
			}
			this._StartTicking();
		}
		Release()
		{
			super.Release();
		}	
		SaveToJson()
		{
			return {
				"t": this.target,
				"dec": this.dec,
				"isr": this.is_rotatingd,
				"curv": this.current_speed,
				"nxv": this.next_speed,
				"rd": this.remain_distance
			};
		}
		LoadFromJson(o)
		{
			this.target = o["t"];
			this.dec = o["dec"];
			this.is_rotating = o["isr"];
			this.current_speed = o["curv"];
			this.remain_distance = o["rd"];
		}
		Tick()
		{
			if (!this.is_rotating)
				return;
			
			const dt = this._runtime.GetDt(this._inst);
			
			if (dt == 0) // can not move if dt == 0
				return;
			
			// this.current_speed...
			this.current_speed = this.next_speed;
			
			// Apply movement to the object
			var distance = this.current_speed * dt;
			this.remain_distance -= distance;
			
			var is_hit_target = false;
			
			// is hit to target at next tick?
			if ( (this.remain_distance <= 0) || (this.current_speed <= 0) )
			{
				this.is_rotating = false;
				this.inst.SetAngle(C3.clampAngle(C3.toRadians(this.target["a"])));
				this.current_speed = 0;
				is_hit_target = true;
			}
			else
			{
				if (this.target["cw"])
					this.inst.SetAngle(this.inst.GetAngle() + C3.clampAngle(C3.toRadians(distance)));
				else
					this.inst.SetAngle(this.inst.GetAngle() - C3.clampAngle(C3.toRadians(distance)));
					
				// assign next speed
				this.next_speed -= (this.dec * dt);
			}
			
			this.inst.SetBboxChanged();
			
			if (is_hit_target)
			{
				this.is_my_call = true;
				this.Trigger(C3.Behaviors.Rex_Turntable.Cnds.OnHitTarget);
				this.is_my_call = false;
			}
		}
		StartSpinning(turns, cw, angle, dec)
		{
			var start = clamp_angle_degrees(C3.toDegrees(this.inst.GetAngle()));
			var end = angle;
			var distance = end - start;
			if (!cw)
				distance = -distance;
			distance = clamp_angle_degrees(distance);
			distance += (360 * turns);
					
			this.target["a"] = end;
			this.target["cw"] = cw;
			this.dec = dec;
			
			this.is_rotating = true;
			this.next_speed = Math.sqrt( 2*dec*distance	);
			this.current_speed = this.next_speed;  
			this.remain_distance = distance;
		}
	};
}